aboutsummaryrefslogtreecommitdiff
path: root/tests/t0001-validate-git-versions.sh
diff options
context:
space:
mode:
Diffstat (limited to 'tests/t0001-validate-git-versions.sh')
-rwxr-xr-xtests/t0001-validate-git-versions.sh45
1 files changed, 45 insertions, 0 deletions
diff --git a/tests/t0001-validate-git-versions.sh b/tests/t0001-validate-git-versions.sh
new file mode 100755
index 0000000..dd84fe3
--- /dev/null
+++ b/tests/t0001-validate-git-versions.sh
@@ -0,0 +1,45 @@
+#!/bin/sh
+
+if [ "${CGIT_TEST_NO_GIT_VERSION}" = "YesPlease" ]; then
+ exit 0
+fi
+
+test_description='Check Git version is correct'
+CGIT_TEST_NO_CREATE_REPOS=YesPlease
+. ./setup.sh
+
+test_expect_success 'extract Git version from Makefile' '
+ sed -n -e "/^GIT_VER[ ]*=/ {
+ s/^GIT_VER[ ]*=[ ]*//
+ p
+ }" ../../Makefile >makefile_version
+'
+
+# Note that Git's GIT-VERSION-GEN script applies "s/-/./g" to the version
+# string to produce the internal version in the GIT-VERSION-FILE, so we
+# must apply the same transformation to the version in the Makefile before
+# comparing them.
+test_expect_success 'test Git version matches Makefile' '
+ ( cat ../../git/GIT-VERSION-FILE || echo "No GIT-VERSION-FILE" ) |
+ sed -e "s/GIT_VERSION[ ]*=[ ]*//" -e "s/\\.dirty$//" >git_version &&
+ sed -e "s/-/./g" makefile_version >makefile_git_version &&
+ test_cmp git_version makefile_git_version
+'
+
+test_expect_success 'test submodule version matches Makefile' '
+ if ! test -e ../../git/.git
+ then
+ echo "git/ is not a Git repository" >&2
+ else
+ (
+ cd ../.. &&
+ sm_oid=$(git ls-files --stage -- git |
+ sed -e "s/^[0-9]* \\([0-9a-f]*\\) [0-9] .*$/\\1/") &&
+ cd git &&
+ git describe --match "v[0-9]*" $sm_oid
+ ) | sed -e "s/^v//" -e "s/-/./" >sm_version &&
+ test_cmp sm_version makefile_version
+ fi
+'
+
+test_done